stacksize(1e7)
xdel(winsid());
funcprot(0);
exec("snr_estim.sci");  
L=40;// Ordre du filtre
DownSampling=6; //Facteur de sous-échantillonnage

n=14; //nombre de bits du quantificateur -ADC
Bw=20e3; //Bande du signal
Fs=250e3; //%Fréquence d'échantillonnage
OSR=Fs/(2*Bw); //Rapport de sur-échantillonnage
Ts=1/Fs;// Période   d'échantillonnage
PE=4;// Pleine échelle du CAN
Vref=PE/2;
N=2^16; //Nombre de points du signal d'entrée
fin_or=5e3;//Fréquence du signal d'entrée
Bin_in=round(fin_or/Fs*N); //Détermination du Bin d'entrée
fin=Bin_in*Fs/N//Fréquence ajustée pour qu'elle soit dans un bin d'entrée
f1_or=32e3;//Fréquence du premier interféreur
Bin1=round(f1_or/Fs*N); //Détermination du Bin du premier interféreur
f1=Bin1*Fs/N//Fréquence ajustée pour qu'elle soit dans un bin 
f2_or=80e3;//Fréquence du 2eme interféreur
Bin2=round(f2_or/Fs*N); //Détermination du 2eme interféreur
f2=Bin2*Fs/N//Fréquence ajustée pour qu'elle soit dans un bin d'entrée


t=0:Ts:(N-1)*Ts; //VecTeur Temps 
f=0:Fs/N:Fs/2-Fs/N; //VecTeur fréquence 

f_dec=0:Fs/N:Bw-Fs/N; //VecTeur fréquence après décimation

Amplitude=5e-3;
Ap=0.25;

w = window('hn',N,12)';   //Fenetrage-Windowing
w_dec = window('hn',floor(N/DownSampling),12)';   //Fenetrage-Windowing

SNDR_BW=0;
SNDR_Nyquist=0;
SNDR_dec=0;
spectre_moy=0
spectre_moy_filter=0;
spectre_moy_dec=0;

hn=eqfir(L+1,[0 Bw/Fs;f1_or/Fs 1/2],[1 0],[0.001 1]);


for i=1:10 //Moyennage sur 10 itéartions avec une phase aléatoire
    x=Amplitude*sin(2*%pi*fin*t+rand()*180)+Ap*sin(2*%pi*f1*t+rand()*180)+Ap*sin(2*%pi*f2*t+rand()*180); //signal d'entrée
   
    D=floor((x+Vref)*2^(n-1)/Vref);  //signal de sortie numerique -Digital Output Signal analog
    D(D<0)=0; // Clipping
    D(D>2^n-1)=2^n-1;//Clipping
    y=(D-2^(n-1))/2^(n-1)*Vref+Vref/2^n; //signal de sortie analogique equivalent -Equivalent Output Signal analog
    y_filter=filter(hn,1,y)
    y_dec=y_filter(1:DownSampling:N-DownSampling);
    
    
    spectre_y=abs(fft(y.*w')).^2;   //Calcul du spectre-Spectrum computation
    spectre_moy=spectre_moy+spectre_y;
  

    spectre_y_filter=abs(fft(y_filter.*w')).^2;   //Calcul du spectre-Spectrum computation
    spectre_moy_filter=spectre_moy_filter+spectre_y_filter;
    

    spectre_y_dec=abs(fft(y_dec.*w_dec')).^2;   //Calcul du spectre-Spectrum computation
    spectre_moy_dec=spectre_moy_dec+spectre_y_dec;    
    
    SNDR_BW=SNDR_BW+snr_estim(y,1,Bin_in,5,OSR);
    SNDR_Nyquist=SNDR_Nyquist+snr_estim(y,1,Bin_in,5,1);
    SNDR_dec=SNDR_dec+snr_estim(y_dec,1,Bin_in,5,1);
    
end




SNDR_BW=SNDR_BW/i;
SNDR_Nyquist=SNDR_Nyquist/i;
SNDR_dec=SNDR_dec/i;

spectre_moy=spectre_moy/i;
spectre_moy_filter=spectre_moy_filter/i;
spectre_moy_dec=spectre_moy_dec/i;





Norm=2.89008^2/N^2;//facteur de normalisation 
scf(2)
plot2d(f,10*log10(spectre_moy(1:N/2)*Norm));
title('spectre de la sortie du CAN')
xlabel('fréquence(Hz)')
ylabel('PSD(dB/bin)')

scf(3)
plot2d(f,10*log10(spectre_moy_filter(1:N/2)*Norm));
title('spectre de la sortie filtrée')
xlabel('fréquence(Hz)')
ylabel('PSD(dB/bin)')
Norm_dec=2.89008^2/(floor(N/DownSampling))^2;//facteur de normalisation 
scf(4)
plot2d(f_dec,10*log10(spectre_moy_dec(1:floor(N*Bw/Fs))*Norm_dec));
title('spectre de la sortie filtrée et décimée')
xlabel('fréquence(Hz)')
ylabel('PSD(dB/bin)')



scf(5)
[hm,fr]=frmag(hn,N/2);
plot2d(f,20*log10(hm))
title('Reponse fréquentielle')
xlabel('fréquence(Hz)')
ylabel('Gain(dB)')

scf(6)
[hm,fr]=frmag(hn,N/2);
plot2d(f_dec,20*log10(hm(1:floor(N*Bw/Fs))))
title('Reponse fréquentielle-zoom bande passante')
xlabel('fréquence(Hz)')
ylabel('Gain(dB)')



disp('Le SNDR dans la bande Nyquist (0 à fs/2)'+string(SNDR_Nyquist)+'dB')
disp('Le SNDR dans la bande utile (0 à 20 KHz)'+string(SNDR_BW)+'dB')
disp('Le SNDR dans la bande utile (0 à 20 KHz) après filtrage et décimation'+string(SNDR_dec)+'dB')






























